/******************************************************************************
 *
 *	POCKET COMMAND for Palm series
 *	ver 1.00
 *	ChoiKyun 2007-2
 *
 *
 *****************************************************************************/
#include <PalmOS.h>
#include "defrsc.h"

#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/

/////////////////////////////////////////////////

void init_screen( void );			// XN[
void init_game_status( void );			// Q[
void make_bitmap_offscreen( void );		// \[Xrbg}bv쐬
void init_main_form( FormPtr );			// CtH[

void pause( EventPtr );				// |[Y
void play_game( void );				// Q[C

Int32 set_event_wait( void );			// ^C}[ݒ
void pause( EventPtr );				// |[Y

void get_hard_key( void );			// n[hL[
Boolean check_hard_key( EventPtr );		// n[hL[Cxg̃`FbN
void get_pen_input( void );			// y

void clear_all_screen( void );			// SʃNAiobNXN[j
void put_bitmap_chr16( Coord, Coord,
                       WinHandle, Int16 );	// 16*16hbgLN^\
void send_lcd( void );				// LCD]

void disp_city_and_sam( void );			// ss{C\
void disp_status( void );			// Xe[^Xʕ\
void disp_cursor( void );			// J[\\
void disp_warhead( void );			// e\
void change_warhead( void );

void fire_my_missile( void );			// @~TC
void fire_enemy( void );			// G~TC
void branch_enemy( Coord, Coord );		// G~TC
void set_enemy_data( Int16, MISSILE_DATA *, Coord, Coord );	// G~TCf[^쐬
void set_new_blast( Coord, Coord );		// Zbg

Boolean check_hit_blast( Int16, Coord, Coord );	// ƃ~TC̓蔻
void check_hit_city( Int16, Coord );		// ssƃ~TC̓蔻

void pset_line_screen( Coord, Coord, Int16 );	// Pset
void add_line_screen( void );			// CXN[

Int16 move_missile( Int16, MISSILE_DATA * );	// ~TCړ,\
Boolean move_missile_sub( MISSILE_DATA * );	// ~TCړTu
Int16 disp_blast( Int16, BLAST_DATA * );	// \
Boolean disp_blast_sub( BLAST_DATA * );		// \Tu

void copy_buf( UInt16 *, UInt16 *, int );	// obt@̃Rs[
void erase_line( Int16, MISSILE_DATA * );	// C`,

void change_se( void );				// ʉ؂芷

void level_up( UInt16 );			// xAbv

void print_press( void );			// PRESS...\
void print_title( void );			// ^Cg\
void disp_num2( Coord, Coord, Int16 );		// Ql\
void disp_num6( Coord, Coord, UInt16 );		// Ul\
void disp_large_num( Coord, Coord, Int16 );	// l\ij

Boolean disp_message( void );			// e탁bZ[W
void disp_mes_ready( void );
void disp_mes_over( void );
void disp_mes_clear( UInt32 );
void disp_total( void );
void disp_bonus( void );

void set_ufo( void );				// UFOo
void move_ufo( void );				// UFOړ
void fire_ufo( Coord, Coord );			// UFO~TC

void set_se( SOUND_TYPE );			// ʉZbg
void sound( void );				// ʉit[j

void all_missile_blast( void );

void init_hiscore( void );			// nCXRA
void check_hiscore( UInt16 );			// nCXRAXV
void input_name( void );			// O
void disp_ranking( void );			// LO\
Boolean score_ranking_handler( EventPtr );	// nh
void clear_hiscore( void );			// LONA

/////////////////////////////////////////////////

Err rom_check( UInt32, UInt16 );
void *get_object_ptr( UInt16 );
Boolean main_form_command( UInt16 );
Boolean main_form_handler( EventPtr );
Boolean app_handle_event( EventPtr );
void event_loop( void );
Err app_start( void );
void app_stop( void );
UInt32 my_app_main( UInt16, MemPtr, UInt16 );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/
// ssW
static const
Coord city_coord[] = {
  BACK_W_BLANK+0,
  BACK_W_BLANK+24,
  BACK_W_BLANK+48,
  BACK_W_BLANK+96,
  BACK_W_BLANK+120,
  BACK_W_BLANK+144
  };


// ʉf[^
// D揇,񐔁it[j,g,, cJԂ
static const
UInt32  se[ sound_cnt ][ SND_LENGTH ] = {
  { 0 },				// no sound
  { 0, 2, 480, 12, 600, 12 },		// click
  { 1, 2, 320, 12, 380, 12 },		// blast
  { 2, 3, 900, 20, 1000, 20, 920, 20 },	// clear
  { 2, 4, 480, 20, 320, 20, 320, 20, 320, 20 },	// gameover
};



/////////////////////////////////////////////////



/************************************************
 *	e\
 ***********************************************/
static void
change_warhead( void )
{
  if( --gs.warhead_wait ) return;
  gs.warhead_wait = DEF_WARHEAD_WAIT;

  gs.warhead_flg ^= 1;
}



/************************************************
 *	e\
 ***********************************************/
static void
disp_warhead( void )
{
  int i;


  if( gs.warhead_flg ) return;

  if( gs.enemy_cnt )
    {
      for( i = 0; i < gs.enemy_cnt; i++ )
        {
          put_bitmap_chr16( gs.enemy[i].curr_x-1,
                            gs.enemy[i].curr_y-1,
                            bmp_chr[ CHR_WARHEAD ],
                            SIZE_SMALL );
        }
    }

  if( gs.branch_cnt )
    {
      for( i = 0; i < gs.branch_cnt; i++ )
        {
          put_bitmap_chr16( gs.branch[i].curr_x-1,
                            gs.branch[i].curr_y-1,
                            bmp_chr[ CHR_WARHEAD ],
                            SIZE_SMALL );
        }
    }

  if( gs.missile_cnt )
    {
      for( i = 0; i < gs.missile_cnt; i++ )
        {
          put_bitmap_chr16( gs.missile[i].curr_x-1,
                            gs.missile[i].curr_y-1,
                            bmp_chr[ CHR_WARHEAD ],
                            SIZE_SMALL );
        }
    }
}



/************************************************
 *	nCXRAF
 ***********************************************/
static void
init_hiscore( void )
{
  int i;


  for( i = 0; i < MAX_RANKING; i++ )
    {
      gs.ranking[i].name[0] = '\0'; // k
      gs.ranking[i].score = 0;
      gs.ranking[i].date[0] = '\0';
    }

  gs.rank_pos = 0;
  StrCopy( &gs.last_name, "----" );
}



/************************************************
 *	nCXRAFǉ
 ***********************************************/
static void
check_hiscore( UInt16 score )
{
  int pos = MAX_RANKING;
  DateTimeType date;


  // nCXRÃ`FbN
  while( pos > 0
         && score > gs.ranking[ pos-1 ].score )
    {
      pos--; // 
    }
  if( pos >= MAX_RANKING ) return;

  // ʈړ
  MemMove( &gs.ranking[ pos+1 ],
           &gs.ranking[ pos ],
           sizeof( HISC_DATA ) * (MAX_RANKING - pos - 1) );

  // O̓
  input_name();
  StrCopy( &gs.ranking[ pos ].name, &gs.last_name );
  // nCXRAXV
  gs.ranking[ pos ].score = score;

  // ̍XV
  TimSecondsToDateTime( TimGetSeconds(), &date );
  DateToAscii( date.month,
               date.day,
               date.year,
               dfYMDWithSlashes,
               &gs.ranking[pos].date );

  gs.rank_pos = pos;
  // XRALO\
  disp_ranking();
}



/************************************************
 *	nCXRAFO
 ***********************************************/
static void
input_name( void )
{
  FormPtr save_form_p,input_p;
  MemHandle name_h;
  char *name_p;
  UInt16 index, button;


  // ݂̃tH[Ҕ
  save_form_p = FrmGetActiveForm();

  // tH[
  input_p = FrmInitForm( Input_nameForm );
  // tB[hINDEX
  index = FrmGetObjectIndex( input_p, input_nameFieldField );
  // tH[JX
  FrmSetFocus( input_p, index );
  // KtBeBXe[g
  GrfSetState( false, false, true );

  // O̓_CAO\
  button = FrmDoDialog( input_p );

  // nh擾
  name_h = FldGetTextHandle( FrmGetObjectPtr( input_p, index) );
  // nh؂藣
  FldSetTextHandle( FrmGetObjectPtr( input_p, index ), 0 );
  // _CAO폜
  FrmDeleteForm( input_p );
  FrmSetActiveForm( save_form_p );

  if( name_h != NULL )
    {
      name_p = MemHandleLock( name_h ); // |C^擾
      if( name_p[0] != '\0' && button == input_nameOkButton )
        {
          // ÕRs[
          StrCopy( &gs.last_name, name_p );
        }
      MemHandleFree( name_h ); // nh
    }
}



/************************************************
 *	XRALO\
 ***********************************************/
static void
disp_ranking( void )
{
  FormPtr save_form_p,form_p;
  Coord y;
  int i;
  char score_string[8];


  // ݂̃tH[̕ۑ
  save_form_p = FrmGetActiveForm();
  // LOtH[
  form_p = FrmInitForm( Rank_bordForm );
  FrmSetActiveForm( form_p );
  FrmDrawForm( form_p );

  WinDrawGrayLine( 5, 31, 156-5, 31 );
  // LO`
  for( i = 0; i < MAX_RANKING; i++ )
    {
      if( !gs.ranking[i].score ) break;

      if( gs.rank_pos == i )
        FntSetFont( boldFont ); // Jg͑
      else
        FntSetFont( stdFont );

      y = i * 16 + 33;
      // AXL[ϊ
      StrIToA( score_string, gs.ranking[i].score );
      StrCat( score_string, "." );

      // O
      WinDrawChars( &gs.ranking[i].name,
                    StrLen( &gs.ranking[i].name ),
                    16,
                    y );
      // XRA
      WinDrawChars( score_string,
                    StrLen( &score_string ),
                    100 - FntCharsWidth( &score_string, StrLen( &score_string ) ),
                    y );
      // t
      WinDrawChars( &gs.ranking[i].date,
                    StrLen( &gs.ranking[i].date ),
                    151 - FntCharsWidth( &gs.ranking[i].date, StrLen( &gs.ranking[i].date ) ),
                    y );
    }
  // nhݒ
  FrmSetEventHandler( form_p, score_ranking_handler );

  FrmDoDialog( form_p );
  FrmDeleteForm( form_p );
  FrmSetActiveForm( save_form_p );
  FntSetFont( stdFont );
}



/************************************************
 *	XRALÕnh
 ***********************************************/
static Boolean
score_ranking_handler( EventPtr event_p )
{
  if( event_p ->eType == ctlSelectEvent )
    {
      if( event_p ->data.ctlSelect.controlID == rank_bordClearButton )
        {
          // A[g\
          if( FrmAlert( Clear_rankingAlert ) == Clear_rankingYes )
            clear_hiscore();

          return true;
        }
    }
  
  return false;
}



/************************************************
 *	nCXRANA
 ***********************************************/
static void
clear_hiscore( void )
{
  int i;
  RectangleType r;


  for( i = 0; i < MAX_RANKING; i++ )
    {
      gs.ranking[i].name[0] = '\0'; // k
      gs.ranking[i].score = 0;
      gs.ranking[i].date[0] = '\0';
    }

  r.topLeft.x = 10; r.topLeft.y = 33;
  r.extent.x = 151-10; r.extent.y = 139-33;
  WinEraseRectangle(&r, 0);
}



/************************************************
 *	UFOZbg
 ***********************************************/
static void
set_ufo( void )
{
  if( gs.ufo.flg || !gs.lv.enemy_num || gs.start & FLG_GAME_OVER
      || RND( 500 ) ) return;

  if( RND( 2 ) )
    {
      // E
      gs.ufo.x = BACK_W_BLANK - 10;
      gs.ufo.x_dir = 4;
    }
  else
    {
      // 
      gs.ufo.x = 160 + BACK_W_BLANK;
      gs.ufo.x_dir = -4;
    }

  gs.ufo.step = (RND( 8 ) << 1) + 8;
  gs.ufo.stop_wait = 0;
  gs.ufo.y = (RND( 20 ) << 1 ) + 8;
  gs.ufo.flg = true;
}



/************************************************
 *	UFOړ
 ***********************************************/
static void
move_ufo( void )
{
  if( gs.ufo.flg )
    {
      if( gs.ufo.stop_wait ) // ~
        {
          if( !--gs.ufo.stop_wait )
            // UFO~TC
            fire_ufo( gs.ufo.x + 4, gs.ufo.y + 2 );
        }
      else
        {
          // Eړ
          if( gs.ufo.step )
            {
              gs.ufo.x += gs.ufo.x_dir;
              gs.ufo.y++;

              if( !(--gs.ufo.step) )
                gs.ufo.stop_wait = 28;
            }
          else
            {
              if( gs.ufo.x_dir > 0 )
                // E
                gs.ufo.x++;
              else
                // 
                gs.ufo.x--;

              if( (gs.ufo.y -= 3) < 6 )
                gs.ufo.flg = false;
            }
        }
      put_bitmap_chr16( gs.ufo.x,
                        gs.ufo.y,
                        bmp_chr[ CHR_UFO ],
                        SIZE_SMALL );
    }
}



/************************************************
 *	ʉZbg
 ***********************************************/
static void
set_se( SOUND_TYPE type )
{
  if( se[ type ][0] >= se[ gs.se_type ][0] )
    {
      gs.se_type = type;
      gs.se_repeat = 0;
    }
}



/************************************************
 *	ʉ t[
 ***********************************************/
static void
sound( void )
{
  SndCommandType cmd;


  if( gs.se_type != no_sound && gs.sound )
    {
      cmd.cmd = sndCmdFrqOn;
      cmd.param1 = se[ gs.se_type ][ 2 + gs.se_repeat*2 ];
      cmd.param2 = se[ gs.se_type ][ 2 + gs.se_repeat*2 + 1 ];
      cmd.param3 = volume;

      SndDoCmd( NULL, &cmd, true );

      if( ++gs.se_repeat > se[gs.se_type][1] ) gs.se_type = no_sound;
    }
}



/************************************************
 *	xAbv
 ***********************************************/
static void
level_up( UInt16 score )
{
  int i;
  // level 1..8
  static const Int16 level_missile[] = {
    0, 16, 24, 32, 40, 48, 56, 64, 64
    };
  static const Int16 level_speed[] = {
    0, 4, 4, 3, 3, 2, 2, 1, 1
    };


  // @ce{x̒e
  if( (gs.lv.missile_num += level_missile[ gs.lv.level ]) > 99 )
    gs.lv.missile_num = 99;
  // Gce
  gs.lv.enemy_num = level_missile[ gs.lv.level ];
  // G~TCˊԊu
  gs.lv.enemy_wait_rel -= ENEMY_LAUNCH_WAIT_STEP;
  // G~TCx
  gs.lv.enemy_speed = level_speed[ gs.lv.level ];

  if( gs.lv.level < MAX_LEVEL ) gs.lv.level++;

  // ss 2000_ȏ
  if( gs.city_cnt < MAX_CITY && score >= 2000 )
    {
      while( 1 )
        {
          i = RND( MAX_CITY );
          if( gs.city_level[ i ] == 2 ) break;
        }
      gs.city_level[i] = 0;
      gs.city_cnt++;
      set_se( clear );
    }

  // ̑Xe[^X
  gs.missile_cnt = gs.enemy_cnt = gs.branch_cnt = gs.blast_cnt = gs.ufo.flg = gs.bonus = 0;
  gs.warhead_wait = DEF_WARHEAD_WAIT;
  gs.warhead_flg = false;
  gs.lv.enemy_wait = 1;

  gs.special = false;
}



/************************************************
 *	e탁bZ[W\
 ***********************************************/
static Boolean
disp_message( void )
{
  static UInt32 disp_sc = 0;
  Boolean result = false;
  UInt16 cmd = gs.start & FLG_GAME_PAUSE;
  UInt32 key, keyf;


  // EFCg
  if( wait )
    {
      wait--;
      return result;
    }

  //Q[Ǐʉ
  if( gs.start & FLG_GAME_SE )
    {
      gs.start &= ~FLG_GAME_SE;
      if( gs.start & FLG_GAME_CLEAR )
        {
          set_se( clear );
          // XRA
          disp_sc = gs.lv.missile_num * 50 + gs.city_cnt * 200;
          // g[^
          gs.score += disp_sc + gs.bonus;
          if( gs.score > 999999 ) gs.score = 999999;
        }
      else if( gs.start & FLG_GAME_OVER )
        {
          set_se( over );
        }
    }

  switch( cmd )
    {
    case FLG_GAME_TITLE:
      print_title(); // ^Cg\

      // Q[Jn L[́y^bv
      if( gs.keyf & ( KEY_1 | KEY_2 | KEY_3 | KEY_4 )
          || (gs.pen_down && (UInt16) (gs.pen_y - 12) < (UInt16) (160-12) ) )
        {
          clear_all_screen();
          gs.start = FLG_GAME_START | FLG_GAME_READY;
          gs.pen_down = false;
          set_se( click );
        }
      result = true;
      break;

      // Q[JnO
    case FLG_GAME_READY:
      disp_mes_ready(); // bZ[W

      // Q[Jn L[́y^bv
      if( gs.keyf & ( KEY_1 | KEY_2 | KEY_3 | KEY_4 )
          || (gs.pen_down && (UInt16) (gs.pen_y - 12) < (UInt16) (160-12) ) )
        {
          gs.start = FLG_GAME_START;
          gs.pen_down = false;
          set_se( click );
        }
      result = true;
      break;

      // NA
    case FLG_GAME_CLEAR:
      disp_mes_clear( disp_sc ); // bZ[W
      disp_bonus(); // {[iXXRA
      disp_total(); // g[^XRA

      // Q[ĊJ L[́y^bv
      if( gs.keyf & ( KEY_1 | KEY_2 | KEY_3 | KEY_4 )
          || (gs.pen_down && (UInt16) (gs.pen_y - 12) < (UInt16) (160-12) ) )
        {
          key = gs.key, keyf = gs.keyf;
          // xAbv
          level_up( disp_sc + gs.bonus );
          clear_all_screen();

          gs.start = FLG_GAME_START | FLG_GAME_READY;
          gs.pen_down = false;
          gs.key = key, gs.keyf = keyf;
          set_se( click );

          disp_sc = 0;
        }
      result = true;
      break;

      // Q[I[o[
    case FLG_GAME_OVER:
      disp_mes_over(); // bZ[W
      disp_total(); // g[^XRA

      // Q[ĊJ L[́y^bv
      if( gs.keyf & ( KEY_1 | KEY_2 | KEY_3 | KEY_4 )
          || (gs.pen_down && (UInt16) (gs.pen_y - 12) < (UInt16) (160-12) ) )
        {
          key = gs.key, keyf = gs.keyf;
          // nCXRAXV
          check_hiscore( gs.score );

          // Q[
          init_game_status();
          clear_all_screen();

          gs.start = FLG_GAME_START | FLG_GAME_TITLE;
          gs.pen_down = false;
          gs.key = key, gs.keyf = keyf;
          gs.bonus = 0;
          set_se( click );
        }
      result = true;
      break;
    }

  return result;
}



/************************************************
 *	bZ[W\-Q[JnO
 ***********************************************/
static void
disp_mes_ready( void )
{
  RectangleType r;


  // l\
  disp_large_num( 98+BACK_W_BLANK, 36, gs.lv.level );
  disp_num2( 96+BACK_W_BLANK, 58, gs.lv.enemy_num );
  disp_num2( 96+BACK_W_BLANK, 68, gs.lv.missile_num );

  // LEVEL
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 41, r.extent.y = 16;
  WinCopyRectangle( bmp_chr[ CHR_MES_LV ], back_screen_h,
                    &r, 52+BACK_W_BLANK, 36, winPaint );
  // ENEMY
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 33, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_MES_EN ], back_screen_h,
                    &r, 31+BACK_W_BLANK, 58, winPaint );
  // MISSILE
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 41, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_MES_MIS ], back_screen_h,
                    &r, 23+BACK_W_BLANK, 68, winPaint );
  // PRESS...
  print_press();
}



/************************************************
 *	bZ[W\-NA
 ***********************************************/
static void
disp_mes_clear( UInt32 score )
{
  RectangleType r;


  // l\
  disp_num2( 96+BACK_W_BLANK, 58, gs.city_cnt );
  disp_num2( 96+BACK_W_BLANK, 68, gs.lv.missile_num );

  disp_num6( 68+BACK_W_BLANK, 82, score ); // XRA

  // LEVEL
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 41, r.extent.y = 16;
  WinCopyRectangle( bmp_chr[ CHR_MES_LV ], back_screen_h,
                    &r, 32+BACK_W_BLANK, 36, winPaint );
  // CLEAR
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 51, r.extent.y = 16;
  WinCopyRectangle( bmp_chr[ CHR_MES_CLEAR ], back_screen_h,
                    &r, 78+BACK_W_BLANK, 36, winPaint );
  // CITY
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 25, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_MES_CITY ], back_screen_h,
                    &r, 39+BACK_W_BLANK, 58, winPaint );
  // MISSILE
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 41, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_MES_MIS ], back_screen_h,
                    &r, 23+BACK_W_BLANK, 68, winPaint );
  // x200
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 21, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_MES_200 ], back_screen_h,
                    &r, 111+BACK_W_BLANK, 59, winPaint );
  // x50
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 16, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_MES_50 ], back_screen_h,
                    &r, 111+BACK_W_BLANK, 69, winPaint );

  // SCORE
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 34, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_SCORE ], back_screen_h,
                    &r, 31+BACK_W_BLANK, 82, winPaint );

  // PTS
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 16, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_PTS ], back_screen_h,
                    &r, 112+BACK_W_BLANK, 82, winPaint );

  // PRESS...
  print_press();
}



/************************************************
 *	bZ[W\-Q[I[o[
 ***********************************************/
static void
disp_mes_over( void )
{
  RectangleType r;


  // GAMEOVER
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 88, r.extent.y = 16;
  WinCopyRectangle( bmp_chr[ CHR_MES_OVER ], back_screen_h,
                    &r, 38+BACK_W_BLANK, 49, winPaint );
  // PRESS...
  print_press();
}



/************************************************
 *	^Cg\
 ***********************************************/
static void
print_title( void )
{
  RectangleType r;


  // TITLE
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 130, r.extent.y = 52;
  WinCopyRectangle( bmp_chr[ CHR_TITLE ], back_screen_h,
                    &r, 15+BACK_W_BLANK, 38, winPaint );
  // PRESS...
  print_press();
}



/************************************************
 *	g[^XRA\
 ***********************************************/
static void
disp_total( void )
{
  RectangleType r;
  WinHandle save;


  save = WinGetDrawWindow();
  WinSetDrawWindow( back_screen_h );
  // wiʂ
  r.topLeft.x = 67+BACK_W_BLANK, r.topLeft.y = 106, r.extent.x = 44, r.extent.y = 8;
  WinEraseRectangle( &r, 0 );

  // g[^XRA
  disp_num6( 68+BACK_W_BLANK, 106, gs.score );

  // TOTAL
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 36, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_TOTAL ], back_screen_h,
                    &r, 29+BACK_W_BLANK, 106, winPaint );

  // PTS
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 16, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_PTS ], back_screen_h,
                    &r, 112+BACK_W_BLANK, 106, winPaint );

  WinSetDrawWindow( save );
}



/************************************************
 *	{[iXXRA\
 ***********************************************/
static void
disp_bonus( void )
{
  RectangleType r;


  // {[iXXRA
  disp_num6( 68+BACK_W_BLANK, 92, gs.bonus );

  // BONUS
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 34, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_BONUS ], back_screen_h,
                    &r, 31+BACK_W_BLANK, 92, winPaint );

  // PTS
  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 16, r.extent.y = 8;
  WinCopyRectangle( bmp_chr[ CHR_PTS ], back_screen_h,
                    &r, 112+BACK_W_BLANK, 92, winPaint );
}



/************************************************
 *	bZ[W\ PRESS...
 ***********************************************/
static void
print_press( void )
{
  WinHandle save;
  FontID id;
  static const char mes_press[] = {
    "press any key or tap screen"
    };


  save = WinGetDrawWindow();

  WinSetDrawWindow( back_screen_h );
  id = FntSetFont( boldFont );

  WinDrawChars( mes_press, StrLen( mes_press ), 12+BACK_W_BLANK, 132 );

  WinSetDrawWindow( save );
  FntSetFont( id );
}



/************************************************
 *	ij\
 ***********************************************/
static void
disp_large_num( Coord x, Coord y, Int16 num )
{
  RectangleType r;

  r.topLeft.x = (num-1) * 6;
  r.topLeft.y = 0;
  r.extent.x = 6;
  r.extent.y = 16;

  WinCopyRectangle( bmp_chr[ CHR_LARGE_NUM ],back_screen_h,
                    &r, x, y, winPaint );
}



/************************************************
 *	W[iC`j
 ***********************************************/
static void
resume_line( void )
{
  int i;


  if( gs.resume )
    {
      // @~TC̃Cĕ`
      for( i = 0; i < gs.missile_cnt; i++ )
        erase_line( MODE_PSET, &gs.missile[i] );

      // G~TC̃Cĕ`
      for( i = 0; i < gs.enemy_cnt; i++ )
        erase_line( MODE_PSET, &gs.enemy[i] );

      // G~TC򃉃Cĕ`
      for( i = 0; i < gs.branch_cnt; i++ )
        erase_line( MODE_PSET, &gs.branch[i] );
    }
}



/************************************************
 *	~TCړ,\
 ***********************************************/
static Int16
move_missile( Int16 count, MISSILE_DATA *data )
{
  int i;
  MISSILE_DATA *curr_p, *end_p;

  if( gs.start & ( FLG_GAME_OVER | FLG_GAME_CLEAR ) ) return count;

  if( count )
    {
      // obt@̌납瑀삷
      curr_p = end_p = data + (count-1);
      for( i = count; i > 0; i--, curr_p-- )
        {
          if( move_missile_sub( curr_p ) ) // ړ true = delete
            {
              // obt@l߂
              copy_buf( curr_p, end_p, sizeof( MISSILE_DATA ) );
              end_p--; count--;
            }
        }
    }
  // IuWFNg
  return count;
}



/************************************************
 *	Aj[V
 ***********************************************/
static Int16
disp_blast( Int16 count, BLAST_DATA *data )
{
  int i;
  BLAST_DATA *curr_p, *end_p;


  if( count )
    {
      // obt@̌납瑀삷
      curr_p = end_p = data + (count-1);
      for( i = count; i > 0; i--, curr_p-- )
        {
          if( disp_blast_sub( curr_p ) ) // Aj[V ture = delete
            {
              // obt@l߂
              copy_buf( curr_p, end_p, sizeof( BLAST_DATA ) );
              end_p--; count--;
            }
        }
    }
  // 
  return count;
}



/************************************************
 *	~TCړ,\Tu
 ***********************************************/
static Boolean
move_missile_sub( MISSILE_DATA *d )
{
  int i;
  Boolean delete = false;


  if( d ->wait-- ) return delete;
  // EFCgĐݒ
  d ->wait = d ->wait_rel;

  // I
  if( ++(d ->count) > d ->count_last )
    {
      // ssƂ̓蔻
      check_hit_city( d ->obj_flg, d ->curr_x );
      // Zbg
      set_new_blast( d ->curr_x, d ->curr_y );
      // C
      erase_line( MODE_PRESET, d );

      return delete = true; // obt@폜
    }

  if( d ->base )
    {
      // Yx[X
      d ->curr_y += d ->obj_flg; // -1 or 1
      d ->e_count += d ->e_val; // 덷l
      // YX
      if( d ->e_count >= d ->count_last )
        {
          d ->e_count -= d ->count_last; // 덷JEg-ŏIJEg
          d ->curr_x += d ->x_inc; // -1 or 1
        }
    }
  else
    {
      // Xx[X
      d ->curr_x += d ->x_inc;
      d ->e_count += d ->e_val;
      // XY
      if( d ->e_count >= d ->count_last )
        {
          d ->e_count -= d ->count_last;
          d ->curr_y += d ->obj_flg;
        }
    }
  // `
  pset_line_screen( d ->curr_x, d ->curr_y, MODE_PSET );

  // Ƃ̓蔻
  if( check_hit_blast( d -> obj_flg, d ->curr_x, d ->curr_y ) )
    {
      // V
      set_new_blast( d ->curr_x, d ->curr_y );
      // C
      erase_line( MODE_PRESET, d );
      delete = true;
    }

  // G~TC
  else if( d ->obj_flg == 1 && ( (UInt16) (d ->curr_y - 30) < (UInt16) 100)
           && d ->branch_flg && !(RND( 200 )) )
    {
      for( i = 0; i < (RND(2)+1); i++ )
        {
          branch_enemy( d ->curr_x, d ->curr_y );
        }
      d ->branch_flg = false;
    }

  return delete;
}



/************************************************
 *	Aj[VTu
 ***********************************************/
static Boolean
disp_blast_sub( BLAST_DATA *d )
{
  Boolean delete = false;


  // `
  put_bitmap_chr16( d ->x,
                    d ->y,
                    bmp_chr[ CHR_BLAST1 + (d ->anime) ],
                    SIZE_LARGE );

  if( d ->anime_wait-- ) return delete;
  d ->anime_wait = DEF_BLAST_WAIT;

  // 폜
  if( ++(d ->anime) == 4 )
    delete = true;

  return delete;
}



/************************************************
 *	ƃ~TC̓蔻
 ***********************************************/
static Boolean
check_hit_blast( Int16 flg, Coord x, Coord y )
{
  int i;


  // G~TĈ
  if( flg == -1 ) return false;

  for( i = 0; i < gs.blast_cnt; i++ )
    {
      if( (UInt16) (x - (gs.blast[i].x-2)) < (UInt16) 20
          && (UInt16) (y - (gs.blast[i].y-2)) < (UInt16) 20 )
        return true;
    }

  return false;
}



/************************************************
 *	~TCƓss̓蔻
 ***********************************************/
static void
check_hit_city( Int16 flg, Coord x )
{
  int i;


  if( flg == -1 ) return;

  // S.A.M.Site Ƃ̓蔻
  if( (UInt16) (x - (SAM_X+BACK_W_BLANK)) < (UInt16) SAM_WIDTH )
    {
      // Q[I[o[
      gs.start = FLG_GAME_START | FLG_GAME_OVER | FLG_GAME_SE;
      gs.sam_level = 1;
      wait = OVER_WAIT;
      return;
    }

  // ssƂ̓蔻
  for( i = 0; i < MAX_CITY; i++ )
    {
      if( (UInt16) (x - city_coord[i]) < (UInt16) CITY_WIDTH
          && gs.city_level[i] < 2 )
        {
          if( ++gs.city_level[i] == 2 )
            // Q[I[o[
            if( !(--gs.city_cnt) )
              {
                gs.start = FLG_GAME_START | FLG_GAME_OVER |FLG_GAME_SE;
                wait = OVER_WAIT;
              }
          return;
        }
    }
}



/************************************************
 *	Ci`̓W[pj
 ***********************************************/
static void
erase_line( Int16 mode, MISSILE_DATA *d )
{
  int i;
  Int16 e_count = 0;
  Coord curr_x = d ->first_x;
  Coord curr_y = d ->first_y;


  for( i = 0; i < d ->count; i++ )
    {
      if( d ->base )
        {
          // Yx[X
          curr_y += d ->obj_flg; // -1 or 1
          e_count += d ->e_val; // 덷l
          // YX
          if( e_count >= d ->count_last )
            {
              e_count -= d ->count_last; // 덷JEg-ŏIJEg
              curr_x += d ->x_inc; // -1 or 1
            }
        }
      else
        {
          // Xx[X
          curr_x += d ->x_inc;
          e_count += d ->e_val;
          // XY
          if( e_count >= d ->count_last )
            {
              e_count -= d ->count_last;
              curr_y += d ->obj_flg;
            }
        }

      pset_line_screen( curr_x, curr_y, mode );
    }
}



/************************************************
 *	obt@̃Rs[iMemMoveHj
 ***********************************************/
static void
copy_buf( UInt16 *dest, UInt16 *sorc, int size )
{
  int i;


  for( i = 0; i < size/2; i++ )
    *dest++ = *sorc++;
}



/************************************************
 *	@~TCf[^Zbg
 ***********************************************/
static void
fire_my_missile( void )
{
  Int16 dis_x, dis_y;


  if( !gs.pen_down || gs.missile_cnt >= MAX_MISSILE
      || !((UInt16) (gs.pen_y - (8+8)) < (145-(8+8)))
      || !gs.lv.missile_num )
    return;

  // {[iXXRAZ
  gs.bonus = gs.bonus + (160 - gs.pen_y);

  // yʒu␳i`悵Ȃ悤Ɂj
  if( gs.pen_x == (SAM_X+BACK_W_BLANK+7) ) gs.pen_x--;

  // 
  dis_x = Abs( gs.pen_x - (SAM_X+BACK_W_BLANK+7) ) + 1;
  dis_y = (160-SAM_HEIGHT) - gs.pen_y + 1;

  // ~TCf[^
  gs.missile[ gs.missile_cnt ].obj_flg = -1;
  gs.missile[ gs.missile_cnt ].first_x = (SAM_X+BACK_W_BLANK) + 7;
  gs.missile[ gs.missile_cnt ].first_y = 160 - SAM_HEIGHT;
  gs.missile[ gs.missile_cnt ].cur_x = gs.pen_x - 3;
  gs.missile[ gs.missile_cnt ].cur_y = gs.pen_y - 3;
  gs.missile[ gs.missile_cnt ].curr_x = (SAM_X+BACK_W_BLANK) + 7;
  gs.missile[ gs.missile_cnt ].curr_y = 160 - SAM_HEIGHT;
  gs.missile[ gs.missile_cnt ].x_inc = gs.pen_x < (SAM_X+BACK_W_BLANK+7) ? -1 : 1;
  gs.missile[ gs.missile_cnt ].count = 1;
  gs.missile[ gs.missile_cnt ].wait = 1;
  gs.missile[ gs.missile_cnt ].wait_rel = DEF_MYMISSILE_WAIT;
  gs.missile[ gs.missile_cnt ].e_count = 0;

  if( dis_x > dis_y )
    {
      // Xx[X
      gs.missile[ gs.missile_cnt ].base = 0;
      gs.missile[ gs.missile_cnt ].count_last = dis_x;
      gs.missile[ gs.missile_cnt ].e_val = dis_y;
    }
  else
    {
      // Yx[X
      gs.missile[ gs.missile_cnt ].base = 1;
      gs.missile[ gs.missile_cnt ].count_last = dis_y;
      gs.missile[ gs.missile_cnt ].e_val = dis_x;
    }

  gs.missile_cnt++;
  gs.lv.missile_num--;
  gs.pen_down = false;

  set_se( click );
}



/************************************************
 *	G~TCˁim[}j
 ***********************************************/
static void
fire_enemy( void )
{
  // ˊԊu
  if( --gs.lv.enemy_wait ) return;
  gs.lv.enemy_wait = gs.lv.enemy_wait_rel;

  // NA
  if( !gs.lv.enemy_num )
    {
      if( !gs.enemy_cnt && !gs.blast_cnt && !gs.branch_cnt )
        {
          gs.start = FLG_GAME_START | FLG_GAME_CLEAR | FLG_GAME_SE;
          wait = CLEAR_WAIT;
        }
      return;
    }

  // 1/2̊mŔ
  if( RND( 2 ) || gs.enemy_cnt >= MAX_ENEMY || !gs.lv.enemy_num ) return;

  set_enemy_data( MODE_ENEMY_NOMAL, &gs.enemy[ gs.enemy_cnt ], 0, 0 );
  gs.enemy_cnt++;
  gs.lv.enemy_num--;
}



/************************************************
 *	G~TCˁij
 ***********************************************/
static void
branch_enemy( Coord x, Coord y )
{
  if( gs.branch_cnt >= MAX_ENEMY ) return;

  set_enemy_data( MODE_ENEMY_BRANCH, &gs.branch[ gs.branch_cnt ], x, y );
  gs.branch_cnt++;
}



/************************************************
 *	UFOG~TC
 ***********************************************/
static void
fire_ufo( Coord x, Coord y )
{
  if( gs.branch_cnt >= MAX_ENEMY ) return;

  // pobt@ƌp
  set_enemy_data( MODE_ENEMY_BRANCH, &gs.branch[ gs.branch_cnt ], x, y );
  gs.branch[ gs.branch_cnt ].wait_rel = 1;

  gs.branch_cnt++;
}



/************************************************
 *	G~TCf[^쐬
 ***********************************************/
static void
set_enemy_data( Int16 mode, MISSILE_DATA *d, Coord x, Coord y )
{
  Coord point_x, point_y, dis_x, dis_y;


  if( mode )
    {
      // ˃|Cg m[}
      d ->first_x = RND( 160 ) + BACK_W_BLANK; // 0..159
      d ->first_y = 6;
      d ->branch_flg = true;
    }
  else
    {
      // ˃|Cg u`
      d ->first_x = x;
      d ->first_y = y;
      d ->branch_flg = false;
    }

  // e|Cgi͕`悵Ȃj
  point_x = RND( 160 ) + BACK_W_BLANK; // 0..159
  if( point_x == d ->first_x ) point_x--;

  point_y = 160-10;

  // 
  dis_x = Abs( point_x - (d ->first_x) ) + 1;
  dis_y = (point_y - d ->first_y) + 1;

  // ~TCf[^
  d ->obj_flg = 1;
  d ->curr_x = d ->first_x;
  d ->curr_y = d ->first_y;
  d ->x_inc = d ->first_x > point_x ? -1 : 1;
  d ->count = 1;
  d ->wait = 1;
  d ->wait_rel = gs.lv.enemy_speed;
  d ->e_count = 0;

  if( dis_x > dis_y )
    {
      // Xx[X
      d ->base = 0;
      d ->count_last = dis_x;
      d ->e_val = dis_y;
    }
  else
    {
      // Yx[X
      d ->base = 1;
      d ->count_last = dis_y;
      d ->e_val = dis_x;
    }
}



/************************************************
 *	Zbg
 ***********************************************/
static void
set_new_blast( Coord x, Coord y )
{
  if( gs.blast_cnt >= MAX_BLAST ) return;

  gs.blast[ gs.blast_cnt ].anime = 0;
  gs.blast[ gs.blast_cnt ].anime_wait = DEF_BLAST_WAIT;
  gs.blast[ gs.blast_cnt ].x = x - 8;
  gs.blast[ gs.blast_cnt ].y = y - 8;

  gs.blast_cnt++;
  set_se( blast );
}



/************************************************
 *	CXN[
 ***********************************************/
static void
add_line_screen( void )
{
  int i;
  UInt32 *screen = back_p + 7 * 8 + 1;
  UInt32 *line = line_p + 7 * 8 + 1;


  for( i = 0; i < GAME_WIN_HEIGHT / 4; i++ )
    {
      *screen++ = *line++;	// 1 20Bytes
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      screen +=2; line += 2;	// ] 8Bytes

      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      screen += 2; line += 2;

      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      screen += 2; line += 2;

      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      *screen++ = *line++;
      screen += 2; line += 2;
    }
}



/************************************************
 *	Pset or PresetiCXN[j
 ***********************************************/
static void
pset_line_screen( Coord x, Coord y, Int16 mode )
{
  UInt8 *screen = (UInt8 *) line_p;
  UInt8 set[] = { 128, 64, 32, 16, 8, 4, 2, 1 };
  UInt8 pre[] = { ~128, ~64, ~32, ~16, ~8, ~4, ~2, ~1 };

  // XN[AhXvZ 224*160dot = y * 28 + x / 8
  screen = (UInt8 *) screen + ((y << 5)-(y << 2)) + (x >> 3);

  if( mode )
    // PRESET
    *screen &= *( pre + (x & 7) );
  else
    // PSET
    *screen |= *( set + (x & 7) );
}



/************************************************
 *	Xe[^Xʕ\
 ***********************************************/
static void
disp_status( void )
{
  int i;
  UInt32 *screen = back_p + 1;
  UInt32 *status;


  if( pre35 )
    status = (UInt32 *) bmp_chr[ CHR_STATUS ] ->displayAddrV20;
  else
    status = (UInt32 *) BmpGetBits( WinGetBitmap( bmp_chr[ CHR_STATUS ] ) );

  for( i = 0; i < 8; i++ )
    {
      *screen++ = *status++;	// 1160hbgi20Bytesj
      *screen++ = *status++;
      *screen++ = *status++;
      *screen++ = *status++;
      *screen++ = *status++;
      screen += 2;		// ]8hbg
    }

  // ʉACR
  put_bitmap_chr16( 151+BACK_W_BLANK,
                    0,
                    bmp_chr[ gs.sound + CHR_SE_OFF ],
                    SIZE_SMALL );

  // x\
  disp_num2( 39+BACK_W_BLANK, 0, gs.lv.level );
  // ~TC\
  disp_num2( 114+BACK_W_BLANK, 0, gs.lv.enemy_num ); // Gce
  disp_num2( 135+BACK_W_BLANK, 0, gs.lv.missile_num ); // @ce
}



/************************************************
 *	SEIIt؂芷
 ***********************************************/
static void
change_se( void )
{
  // ̈攻{L[
  if( (gs.pen_down && gs.pen_y < 12 )
      || gs.keyf == KEY_DOWN )
    {
      gs.sound ^= 1;
      gs.pen_down = false;
      set_se( click );
    }
}



/************************************************
 *	J[\\
 ***********************************************/
static void
disp_cursor( void )
{
  int i;


  if( gs.missile_cnt )
    {
      for( i = 0; i < gs.missile_cnt; i++ )
        {
          put_bitmap_chr16( gs.missile[i].cur_x,
                            gs.missile[i].cur_y,
                            bmp_chr[ CHR_CURSOR ],
                            SIZE_SMALL );
        }
    }
}



/************************************************
 *	C{ss\
 ***********************************************/
static void
disp_city_and_sam( void )
{
  int i;


  // C\
    put_bitmap_chr16( BACK_W_BLANK+SAM_X,
                      160-16,
                      bmp_chr[ CHR_SAM + gs.sam_level ],
                      SIZE_LARGE );

  // ss\
  for( i = 0; i < MAX_CITY; i++ )
    put_bitmap_chr16( city_coord[i],
                      160-8,
                      bmp_chr[ CHR_CITY1 + gs.city_level[i] ],
                      SIZE_SMALL );
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
static void
send_lcd( void )
{
  int i;
  UInt32 *screen = lcd_p, *back = back_p + 1;


  for( i = 0; i < LCD_HEIGHT / 4; i++)
    {
      *screen++ = *back++;	// 1 20Bytes
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += 2;		// ] 8Bytes

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += 2;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += 2;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += 2;
    }
}



/************************************************
 *	SʃNAiobNXN[{CXN[j
 ***********************************************/
static void
clear_all_screen( void )
{
  int i;
  UInt32 *screen = back_p;


  for( i = 0; i < BACK_HEIGHT*(BACK_WIDTH/8) / 4; i++ )
    {
      *screen++ = 0L;
    }

  screen = line_p;
  for( i = 0; i < BACK_HEIGHT*(BACK_WIDTH/8) / 4; i++ )
    {
      *screen++ = 0L;
    }
}



/************************************************
 *	rbg}bvLN^\iobNXN[j
 *      LARGE:	16*16hbg	OR
 *      SMALL:	 16*8hbg	OR
 ***********************************************/
static void
put_bitmap_chr16( Coord x, Coord y, WinHandle chr_no, Int16 size )
{
  int i;
  UInt16 *chr_buff;
  UInt32 shift;
  UInt32 *screen = back_p;


  if( pre35 )
    chr_buff = (UInt16 *) chr_no ->displayAddrV20;
  else
    chr_buff = (UInt16 *) BmpGetBits( WinGetBitmap( chr_no ) );

  // XN[AhXvZ 224*160dot = y * 28 + x / 16
  screen = (UInt16 *) screen + ((y << 4)-(y << 1)) + (x >> 4);

  for( i = 0; i < size; i++ )
    {
      // LN^Vtg 32rbg
      shift = ( ( (UInt32) *chr_buff ) << ( 16 - ( x & 15 ) ) );
      // XN[ OR 32rbg
      *screen |= shift;
      screen = (UInt8 *) screen + 28; chr_buff++;
    }
}



/************************************************
 *	Ql\
 ***********************************************/
static void
disp_num2( Coord x, Coord y, Int16 num )
{
  put_bitmap_chr16( x+NUM_WIDTH, y, bmp_chr[ CHR_NUM + (num % 10) ], SIZE_SMALL );
  num /= 10;
  put_bitmap_chr16( x, y, bmp_chr[ CHR_NUM + num ], SIZE_SMALL );
}



/************************************************
 *	Ul\
 ***********************************************/
static void
disp_num6( Coord x, Coord y, UInt16 num )
{
  int i, pos = 5 * NUM_WIDTH;


  for( i = 0; i < 6; i++ )
    {
      put_bitmap_chr16( x+pos, y, bmp_chr[ CHR_NUM + (num % 10) ], SIZE_SMALL );
      num /=10;
      pos -= NUM_WIDTH;
    }
}



/************************************************
 *	BR}h@SẴ~TCj@c~TCȂI
 ***********************************************/
static void
all_missile_blast( void )
{
  int i;


  // exP̂
  if( gs.special ) return;

  gs.blast_cnt = 0;
  // ~TCSj
  for( i = 0; i < gs.enemy_cnt; i++ )
    {
      set_new_blast( gs.enemy[i].curr_x, gs.enemy[i].curr_y );
    }
  for( i = 0; i < gs.branch_cnt; i++ )
    {
      set_new_blast( gs.branch[i].curr_x, gs.branch[i].curr_y );
    }

  gs.enemy_cnt = 0;
  gs.branch_cnt = 0;
  gs.special = true;

  clear_all_screen();
}



/************************************************
 *	\[Xrbg}bvItXN[쐬
 ***********************************************/
static void
make_bitmap_offscreen( void )
{
  int i;
  WinHandle save;
  UInt16 error;
  MemHandle bitmap_h;
  BitmapPtr bitmap_p;


  // ݂̃nhҔ
  save = WinGetDrawWindow();

  // LN^@ItXN[쐬
  for( i = 0; i < MAX_BMP; i++ )
    {
      bitmap_h = DmGetResource( bitmapRsc, 1000 + i );
      bitmap_p = MemHandleLock( bitmap_h );

      bmp_chr[i] = WinCreateOffscreenWindow( bitmap_p ->width, bitmap_p ->height,
                                             screenFormat, &error );
      // G[
      ErrFatalDisplayIf( error, "Error loading images" );

      // ItXN[ɕ`
      WinSetDrawWindow( bmp_chr[i] );
      WinDrawBitmap( bitmap_p, 0, 0 );

      MemPtrUnlock( bitmap_p );
      DmReleaseResource( bitmap_h );
    }

  // nhA
  WinSetDrawWindow( save );
}



/************************************************
 *	n[hL[
 ***********************************************/
static void
get_hard_key( void )
{
  // key = A, keyf = ͂߂̈̂
  gs.keyf = gs.key;
  gs.keyf ^= 0xffffffff;

  gs.key = KeyCurrentState();
  gs.keyf &= gs.key;
}



/************************************************
 *	n[hL[̃`FbN
 ***********************************************/
static Boolean
check_hard_key( EventPtr event_p )
{
  Boolean handled = false;


  switch( event_p ->eType )
    {
    case keyDownEvent:
      switch( event_p ->data.keyDown.chr )
        {
        case vchrHard1:
        case vchrHard2:
        case vchrHard3:
        case vchrHard4:
        case vchrPageDown:
          gs.start |= FLG_GAME_START; // |[Y
          handled = true;
          break;

        case vchrPageUp:
          gs.start ^= FLG_GAME_START; // |[Y
          handled = true;
          break;
        }
    }

  return handled;
}



/************************************************
 *	|[Y
 ***********************************************/
static void
pause( EventPtr event_p )
{
  switch( event_p ->eType )
    {
    case winEnterEvent:
      if( event_p ->data.winEnter.enterWindow == (WinHandle) FrmGetFormPtr( MainForm )
          && event_p ->data.winEnter.enterWindow == (WinHandle) FrmGetFirstForm() )
        gs.start |= FLG_GAME_START;
      break;

    case winExitEvent:
      if( event_p ->data.winExit.exitWindow == (WinHandle) FrmGetFormPtr( MainForm ) )
        gs.start &= FLG_GAME_PAUSE;
      break;
    }
}



/************************************************
 *	XN[̏
 ***********************************************/
static void
init_screen( void )
{
  UInt16 error;
  UInt32 rom_ver;
  UInt32 width = 160, height = 160, depth = 1;


  // ݂̐F[x擾
  WinScreenMode( winScreenModeGet, &save_screen.width,
                 &save_screen.height, &save_screen.depth,
                 NULL );

  // 160*160 1bit ݒ
  WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );

  // obNXN[쐬
  back_screen_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT,
                                            screenFormat, &error );
  // G[
  ErrFatalDisplayIf( error, "Error Create BackScreen" );

  // CXN[쐬
  line_screen_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT,
                                            screenFormat, &error );
  // G[
  ErrFatalDisplayIf( error, "Error Create LineScreen" );

  // OS3.5O
  FtrGet( sysFtrCreator, sysFtrNumROMVersion, &rom_ver );
  if( rom_ver < PalmRomVer350 ) pre35 = true;

  // XN[̃|C^擾
  if( pre35 )
    {
      back_p = (UInt32 *) back_screen_h ->displayAddrV20;
      line_p = (UInt32 *) line_screen_h ->displayAddrV20;
      lcd_p = (UInt32 *) WinGetDisplayWindow() ->displayAddrV20;
    }
  else
    {
      back_p = (UInt32 *) BmpGetBits( WinGetBitmap( back_screen_h ) );
      line_p = (UInt32 *) BmpGetBits( WinGetBitmap( line_screen_h ) );
      lcd_p = (UInt32 *) BmpGetBits( WinGetBitmap( WinGetDisplayWindow() ) );
    }

  // XN[NA
  clear_all_screen();
}



/************************************************
 *	Q[̏
 ***********************************************/
static void
init_game_status( void )
{
  int i;


  // Xe[^X
  gs.start = FLG_GAME_TITLE;	// Q[^Cg
  gs.resume = false;		// W[It
  gs.key = gs.keyf = 0;		// L[̓tO
  gs.se_type = no_sound;

  gs.score = 0;			// XRA

  // x
  gs.lv.level = 1;				// x
  gs.lv.missile_num = DEF_MY_MISSILE_NUM;	// @ce
  gs.lv.enemy_num = DEF_ENEMY_NUM;		// G~TC
  gs.lv.enemy_wait = 1;				// GˊԊu
  gs.lv.enemy_wait_rel = DEF_ENEMY_LAUNCH_WAIT;
  gs.lv.enemy_speed = DEF_ENEMY_SPEED;		// G~TCx

  gs.missile_cnt = 0;		// @~TC
  gs.enemy_cnt = 0;		// G~TC
  gs.branch_cnt = 0;		// G~TC
  gs.blast_cnt = 0;		// 
  gs.city_cnt = MAX_CITY;	// ss

  gs.ufo.flg = false;		// UFO
  gs.special = false;		// XyVR}htO

  gs.warhead_wait = DEF_WARHEAD_WAIT;	// e\EFCg
  gs.warhead_flg = false;		// e\tO

  // S.A.M.site 
  gs.sam_level = 0;
  // ss
  for( i = 0; i < MAX_CITY; i++ )
    gs.city_level[i] = 0;
}



/************************************************
 *	Q[̃C
 ***********************************************/
static void
play_game( void )
{
  if( !(gs.start & FLG_GAME_START) ) return;	// Q[JnO|[Y
  if( TimGetTicks() < event_wait + DEF_EVENT_TICK ) return;  // 20msƎs

  // TickXV
  event_wait = TimGetTicks();

  //  WinScreenLock( winLockCopy );

  get_hard_key();		// n[hL[擾

  if( !disp_message() )		// e탁bZ[W̏
    {
      add_line_screen();	// CXN[
      fire_enemy();		// G~TC
      fire_my_missile();	// @~TC
      set_ufo();		// UFOo
      disp_cursor();		// J[\\
      change_warhead();		// e\؂ւ
      disp_warhead();		// e\

      // @~TCړ
      gs.missile_cnt = move_missile( gs.missile_cnt, &gs.missile );
      // G~TCړ
      gs.enemy_cnt = move_missile( gs.enemy_cnt, &gs.enemy );
      // G~TC
      gs.branch_cnt = move_missile( gs.branch_cnt, &gs.branch );
      // Aj
      gs.blast_cnt = disp_blast( gs.blast_cnt, &gs.blast );
      // UFOړ
      move_ufo();
    }
  disp_city_and_sam();		// C{ss\
  disp_status();		// Xe[^X\

  send_lcd();			// obNXN[LCDɃRs[
  change_se();			// ʉ؂芷
  sound();			// ʉit[j

  //  WinScreenUnlock();
}



/************************************************
 *	ROM̃o[W`FbN
 *	PalmOS 3.00ȍ~H
 ***********************************************/
static Err
rom_check( UInt32 requiredVersion, UInt16 launchFlags )
{
  UInt32 rom_ver;


  FtrGet( sysFtrCreator, sysFtrNumROMVersion, &rom_ver );

  if( rom_ver < PalmRomVer300 )
    {
      if( ( launchFlags & ( sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp ) )
          == ( sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp ) )
        {
          // A[g\
          FrmAlert( RomIncompatibleAlert );
          if( rom_ver < ourMinVersion )
            AppLaunchWithCommand( sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL );
        }
      return sysErrRomIncompatible;
    }

  return errNone;
}



/************************************************
 *	Cxg[ṽEFCgݒ
 ***********************************************/
static Int32
set_event_wait( void )
{
  Int32 wait;


  // Q[JnO^f
  if( !(gs.start & FLG_GAME_START) ) return wait = -1;

  // EFCg ő20ms 50t[
  wait = event_wait + DEF_EVENT_TICK - TimGetTicks();
  if( wait < 0 ) wait = 0;

  return wait;
}



/************************************************
 *	tH[̃IuWFNg̃|C^擾
 ***********************************************/
static void *
get_object_ptr( UInt16 object_ID )
{
  FormPtr frm_p;


  frm_p = FrmGetActiveForm();
  return FrmGetObjectPtr( frm_p, FrmGetObjectIndex( frm_p, object_ID ) );
}



/************************************************
 *	CtH[j[R}h
 ***********************************************/
static Boolean
main_form_command( UInt16 command )
{
  Boolean handled = false;
  FormPtr frm_p;


  switch( command )
    {
    case MainOptionsNew:
      gs.start = FLG_GAME_START;

      MenuEraseStatus( 0 );
      // j[Q[
      init_game_status();
      clear_all_screen();

      gs.start = FLG_GAME_START | FLG_GAME_TITLE;
      event_wait = TimGetTicks();
      handled = true;
      break;

    case MainOptionsScore:
      // XRALO
      disp_ranking();

      event_wait = TimGetTicks();
      handled = true;
      break;

    case MainOptionsAboutCOMMAND:
      // AoEgʂ̕\
      MenuEraseStatus( 0 );
      frm_p = FrmInitForm( AboutForm );
      FrmDoDialog( frm_p );
      FrmDeleteForm( frm_p );

      // TickXVĂ
      event_wait = TimGetTicks();
      handled = true;
      break;

    case MainOptionsHelp:
      // wv
      FrmHelp( key_helpString );
      event_wait = TimGetTicks();
      handled = true;
      break;
    }

  return handled;
}



/************************************************
 *	CtH[Cxgnh
 ***********************************************/
static Boolean
main_form_handler( EventPtr event_p )
{
  Boolean handled = false;
  FormPtr frm_p;


  switch( event_p ->eType )
    {
    case menuEvent:
      return main_form_command( event_p ->data.menu.itemID );

    case frmOpenEvent:
      frm_p = FrmGetActiveForm();
      FrmDrawForm( frm_p );
      handled = true;
      break;

    case menuCmdBarOpenEvent:
      gs.start &= FLG_GAME_PAUSE;
      // nhȂ
      // handled = true;
      break;

    case penMoveEvent:
    case penUpEvent:
      gs.pen_down = false;
      handled = true;
      break;

    case penDownEvent:
      gs.pen_down = true;
      // ʒu␳
      gs.pen_x = event_p ->screenX + BACK_W_BLANK;
      gs.pen_y = event_p ->screenY + BACK_H_BLANK;

      gs.start |= FLG_GAME_START;
      handled = true;
      break;

    case keyDownEvent:
      if( event_p ->data.keyDown.chr == 'b' ) // BR}h "b"
        {
          // SẴ~TCj
          gs.score = 0; // XRA͖v
          gs.bonus = 0;
          all_missile_blast();
        }
      else if( event_p ->data.keyDown.chr == 'l' ) // BR}h"l"
        {
          // ̃x
          if( gs.start & FLG_GAME_OVER ) break;
          gs.score = 0;
          gs.bonus = 0;
          gs.lv.missile_num = 0;
          level_up( 0 );
          clear_all_screen();
          gs.start = FLG_GAME_START | FLG_GAME_READY;
        }
      handled = true;
      break;
    }

  return handled;
}



/************************************************
 *	tH[̃[h
 ***********************************************/
static Boolean
app_handle_event( EventPtr event_p )
{
  UInt16 form_id;
  FormPtr frm_p;


  if( event_p ->eType == frmLoadEvent )
    {
      form_id = event_p ->data.frmLoad.formID;
      frm_p = FrmInitForm( form_id );
      FrmSetActiveForm( frm_p );

      switch( form_id )
        {
        case MainForm:
          FrmSetEventHandler( frm_p, main_form_handler );
          break;
        }

      return true;
    }

  return false;
}



/************************************************
 *	Cxg[v
 ***********************************************/
static void
event_loop( void )
{
  UInt16 error;
  EventType event;


  do
    {
      // Cxg擾
      EvtGetEvent( &event, set_event_wait() );

      // |[Y
      pause( &event );
      // Q[̃C
      play_game();

      // n[hL[ŃXLbv
      if( !check_hard_key( &event ) )
        if( SysHandleEvent( &event ) ) continue;

      if( !MenuHandleEvent( 0, &event, &error ) )
        if( !app_handle_event( &event ) )
          FrmDispatchEvent( &event );
    }
  while( event.eType != appStopEvent );
}



/************************************************
 *	AvJn
 ***********************************************/
static Err
app_start( void )
{
  UInt16 size;


  // XN[
  init_screen();
  //rbg}bv쐬
  make_bitmap_offscreen();

  // _}CY
  SysRandom ( TimGetTicks() );

  // ʉON
  gs.sound = true;

  // XRALO
  init_hiscore();

  // vt@X擾
  size = sizeof( GAME_STATE );

  if( PrefGetAppPreferences( appFileCreator, appPrefID, &gs, &size, true )
      != appPrefVersionNum )
    {
      // Q[̏
      init_game_status();
    }
  // TCY̊mF
  if( size != sizeof( GAME_STATE ) )
    {
      init_game_status();
      init_hiscore();
    }

  // W[iC`j
  resume_line();

  // {[擾
  volume = PrefGetPreference( prefGameSoundVolume );
  // EFCg
  wait = 0;
  // {[iX
  gs.bonus = 0;

  // ݂TICKl擾
  event_wait = TimGetTicks();

  return errNone;
}



/************************************************
 *	AvI
 ***********************************************/
static void
app_stop( void )
{
  int i;


  // SẴItXN[
  for( i = 0; i < MAX_BMP; i++ )
    WinDeleteWindow( bmp_chr[i], false );

  // obNXN[
  WinDeleteWindow( back_screen_h, false );
  // CXN[
  WinDeleteWindow( line_screen_h, false );

  // ʂ߂
  WinScreenMode( winScreenModeSet,
                 &save_screen.width,
                 &save_screen.height,
                 &save_screen.depth,
                 NULL );

  // Q[~
  gs.start &= FLG_GAME_PAUSE;
  // W[
  gs.resume = true;

  // Q[̏ԕۑ
  PrefSetAppPreferences( appFileCreator, appPrefID, appPrefVersionNum,
                         &gs, sizeof( GAME_STATE ), true );

  // tH[
  FrmCloseAllForms();
}



/************************************************
 *	C
 ***********************************************/
static UInt32
my_app_main( UInt16 cmd, MemPtr /*cmdPBP*/, UInt16 launchFlags )
{
  Err error;

  // ROM`FbN
  error = rom_check( ourMinVersion, launchFlags );
  if( error ) return error;

  switch( cmd )
    {
    case sysAppLaunchCmdNormalLaunch:
      error = app_start();
      if( error ) return error;

      FrmGotoForm( MainForm );
      event_loop();
      app_stop();
      break;

    default:
      break;
    }

  return errNone;
}



/************************************************
 *	Gg[
 ***********************************************/
UInt32
PilotMain( UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags )
{
  return my_app_main( cmd, cmdPBP, launchFlags );
}



