/******************************************************************************
 *
 *	POCKET COMMAND for PALM series
 *	ver 1.00
 *	ChoiKyun 2007-2
 *
 *
 *****************************************************************************/

#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



/************************************************
 *	萔
 ***********************************************/
// o[W
#define appFileCreator		'cK01'
#define appVersionNum		0x01
#define appPrefID		0x00
#define appPrefVersionNum	0x02


// o[W
#define ourMinVersion	sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define PalmRomVer300	sysMakeROMVersion(3,0,0,sysROMStageRelease,0)
#define PalmRomVer350	sysMakeROMVersion(3,5,0,sysROMStageRelease,0)


// Cxg̃EFCg 20ms@50f/s
#define DEF_EVENT_TICK 2


// @~TCEFCg
#define DEF_MYMISSILE_WAIT 1
// EFCg
#define DEF_BLAST_WAIT 4


// @~TCl
#define DEF_MY_MISSILE_NUM 30
// G~TCl
#define DEF_ENEMY_NUM 8
// G~TCˊԊu
#define DEF_ENEMY_LAUNCH_WAIT 60
// G~TCx
#define DEF_ENEMY_SPEED (1+4)

// e\EFCg
#define DEF_WARHEAD_WAIT 25

// XRAl[
#define DEF_NAME_LEN 4


// G~TCˊԊuXebv
#define ENEMY_LAUNCH_WAIT_STEP 5

// G~TC[h
#define MODE_ENEMY_BRANCH 0
#define MODE_ENEMY_NOMAL 1


// Q[̐istO
#define FLG_GAME_PAUSE (~1)
#define FLG_GAME_START 1
#define FLG_GAME_READY 2
#define FLG_GAME_CLEAR 4
#define FLG_GAME_OVER 8
#define FLG_GAME_TITLE 16
// Q[IʉtO
#define FLG_GAME_SE 128


// `惂[h
#define MODE_PSET 0
#define MODE_PRESET 1


// `TCY
#define SIZE_LARGE 16
#define SIZE_SMALL 8


// n[hL[
#define KEY_RIGHT keyBitHard3
#define KEY_LEFT keyBitHard2
#define KEY_UP keyBitPageUp
#define KEY_DOWN keyBitPageDown

#define KEY_1 keyBitHard1
#define KEY_2 keyBitHard2
#define KEY_3 keyBitHard3
#define KEY_4 keyBitHard4


// LN^
#define MAX_BMP 39
// ss
#define MAX_CITY 6
// G~TC
#define MAX_ENEMY 12
// @~TC
#define MAX_MISSILE 3
// 
#define MAX_BLAST (MAX_ENEMY+MAX_MISSILE)
// x
#define MAX_LEVEL 8

// XRALO
#define MAX_RANKING 6


// obNXN[TCY
#define BACK_WIDTH (160+32+32) // E]32hbg
#define BACK_HEIGHT 160

#define BACK_W_BLANK 32
#define BACK_H_BLANK 0


// XN[TCY
#define LCD_WIDTH 160
#define LCD_HEIGHT 160

// Q[EBhETCY
#define GAME_WIN_WIDTH 160
#define GAME_WIN_HEIGHT (160-8)


// LN^No
#define CHR_STATUS 0

#define CHR_SAM 1
#define CHR_CRASH_SAM 2

#define CHR_CITY1 3
#define CHR_CITY2 4
#define CHR_CITY3 5

#define CHR_CURSOR 6

#define CHR_BLAST1 7
#define CHR_BLAST2 8
#define CHR_BLAST3 9
#define CHR_BLAST4 10

#define CHR_SE_OFF 11
#define CHR_SE_ON 12

#define CHR_NUM 13 // 0..9

#define CHR_UFO 23

#define CHR_MES_LV 24
#define CHR_MES_EN 25
#define CHR_MES_MIS 26
#define CHR_MES_CITY 27
#define CHR_MES_CLEAR 28
#define CHR_MES_OVER 29
#define CHR_MES_200 30
#define CHR_MES_50 31
#define CHR_LARGE_NUM 32
#define CHR_PTS 33
#define CHR_TITLE 34
#define CHR_TOTAL 35
#define CHR_BONUS 36
#define CHR_WARHEAD 37
#define CHR_SCORE 38


// tHgTCY
#define NUM_WIDTH 7


// CW
#define SAM_X 72
#define SAM_WIDTH 15
#define SAM_HEIGHT 13

#define CITY_WIDTH 16


// Q[I[o[̃EFCg
#define OVER_WAIT 40
// NÃEFCg
#define CLEAR_WAIT 20


// ʉf[^
#define SND_LENGTH 10


///////////////////////////////////////}N

// _
#define RND(N) ((((Int32) SysRandom (0)) * (N)) / ((Int32) sysRandomMax + 1))



/************************************************
 *	錾
 ***********************************************/
// ~TCf[^
typedef struct
{
  Int16 obj_flg;	// tOi-1:@@1:Gj
  Coord first_x;	// n_X
  Coord first_y;	// n_Y
  Coord cur_x;		// I_iJ[\jX
  Coord cur_y;		// I_iJ[\jY
  Coord curr_x;		// X
  Coord curr_y;		// Y
  Int16 x_inc;		// ړXi-1 or 1j
  Int16 base;		// x[XtOi0:X or 1:Yj
  Int16 count;		// ݋JEg
  Int16 count_last;	// ŏIJEg
  Int16 wait;		// EFCg
  Int16 wait_rel;	// EFCg[h
  Int16 e_count;	// 덷JEg
  Int16 e_val;		// 덷l
  Boolean branch_flg;	// tO
} MISSILE_DATA;


// 
typedef struct
{
  Int16 anime;		// Ajp^[
  Int16 anime_wait;	// AjEFCg
  Coord x;		// X
  Coord y;		// Y
} BLAST_DATA;


// xǗ
typedef struct
{
  Int16 level;		// x
  Int16 missile_num;	// @ce
  Int16 enemy_num;	// Gce
  Int16 enemy_wait;	// GˊԊu
  Int16 enemy_wait_rel;	// GˊԊu[h
  Int16 enemy_speed;	// G~TCx
} LEVEL_DATA;


// UFO
typedef struct
{
  Boolean flg;		// otO
  Coord x;		// XW
  Coord y;		// YW
  Int16 x_dir;		// ړ -4,4
  Int16 step;		// ړ
  Int16 stop_wait;	// ~
} UFO_DATA;


// ʉԍ
typedef enum 
{
  no_sound,		// Ȃ
  click,		// NbN
  blast,		// 
  clear,		// Q[NA
  over,			// Q[I[o[
  sound_cnt
} SOUND_TYPE;


// nCXRA
typedef struct
{
  char name[DEF_NAME_LEN+1];	// O
  UInt32 score;			// nCXRA
  char date[dateStringLength];	// t
} HISC_DATA;


// Q[̐is
typedef struct
{
  UInt16 start;			// Q[istO
  Boolean resume;		// W[tO
  UInt32 key;			// L[tO
  UInt32 keyf;			// L[tO2
  Boolean pen_down;		// ytO
  Int16 pen_x;			// yXW
  Int16 pen_y;			// yYW
  Boolean sound;		// ʉtO

  Boolean special;		// R}htO

  SOUND_TYPE se_type;		// ʉԍ
  Int16 se_repeat;		// ʉJEgit[j

  LEVEL_DATA lv;		// x
  Int16 missile_cnt;		// ~TC
  Int16 enemy_cnt;		// G~TC
  Int16 branch_cnt;		// G~TC
  Int16 blast_cnt;		// 
  Int16 city_cnt;		// ss

  Int16 warhead_wait;		// e\EFCg
  Boolean warhead_flg;		// e\tO

  Int16 city_level[MAX_CITY];	// ssjx
  Int16 sam_level;		// S.A.M.Sitejx

  MISSILE_DATA missile[MAX_MISSILE];	// ~TCf[^
  MISSILE_DATA enemy[MAX_ENEMY];
  MISSILE_DATA branch[MAX_ENEMY];	// G~TCp
  BLAST_DATA blast[MAX_MISSILE+(MAX_ENEMY*2)];
  UFO_DATA ufo;

  UInt32 score;			// XRA
  UInt32 bonus;			// {[iXXRA
  char last_name[DEF_NAME_LEN+1];	// Ōɓ͂O
  Int16 rank_pos;			// LO݈ʒu
  HISC_DATA ranking[MAX_RANKING];	// XRALO
} GAME_STATE;


// ʃ[h̕ۑ
typedef struct
{
  UInt32 width;
  UInt32 height;
  UInt32 depth;
} SAVE_SCREEN_MODE;



/************************************************
 *	O[oϐ
 ***********************************************/
// ʃ[h̕ۑ
GLOBAL SAVE_SCREEN_MODE save_screen;

// OS3.5ȍ~
GLOBAL Boolean pre35 = false;

// obNXN[nh
GLOBAL WinHandle back_screen_h;
// obNXN[iCj
GLOBAL WinHandle line_screen_h;

// obNXN[|C^
GLOBAL UInt32 *back_p;
// obNXN[iCj
GLOBAL UInt32 *line_p;
// LCDobt@|C^
GLOBAL UInt32 *lcd_p;

// Cxg[ṽEFCg
GLOBAL Int32 event_wait;

// Q[̐is
GLOBAL GAME_STATE gs;

// rbg}bvLN^nh
GLOBAL WinHandle bmp_chr[ MAX_BMP ];

// TEh̃{[
GLOBAL UInt16 volume;

// EFCg
GLOBAL Int16 wait;

/************************************************
 *	vg^Cv
 ***********************************************/
// game.c
UInt32 PilotMain( UInt16, MemPtr, UInt16 );



#undef GLOBAL
#undef GLOBAL_VAL
